package com.loafle.bridge.discoveryport.entity;

import com.loafle.bridge.discoveryport.constant.PortType;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Entity
public class DiscoveryPort {

    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

//    @ManyToOne
//    @JoinColumn(name = "HOST_ID", nullable = false)
//    private DiscoveryHost host;

    @Column(name = "PORT_TYPE",nullable = false)
    @Enumerated(EnumType.STRING)
    private PortType portType;

    @Column(name = "PORT_NUMBER",nullable = false)
    private short portNumber;

    @OneToMany(mappedBy = "port" , fetch = FetchType.LAZY)
    private List<ServiceScanHistory> histories;

    @Column(name = "CREATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Column(name = "UPDATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false)
    private Date updateDate;


    public DiscoveryPort() {}

    public DiscoveryPort(PortType type, short portNumber) {
        this.portType = type;
        this.portNumber = portNumber;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public PortType getPortType() {
        return portType;
    }

    public void setPortType(PortType portType) {
        this.portType = portType;
    }

    public short getPortNumber() {
        return portNumber;
    }

    public void setPortNumber(short portNumber) {
        this.portNumber = portNumber;
    }

    public List<ServiceScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<ServiceScanHistory> histories) {
        this.histories = histories;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }
}
