package com.loafle.bridge.discoveryport.entity;

import com.loafle.bridge.discoveryport.constant.DirectionType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 16. 11. 15.
 */

@Entity
public class ServiceScanHistory {

    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "PORT_ID")
    private DiscoveryPort port;

    @Column(name = "SERVICE_NAME", nullable = false)
    private String serviceName;

    @Column(name = "DIRECTION", nullable = false)
    @Enumerated(EnumType.STRING)
    private DirectionType direction;

    @Column(name = "CREATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Lob
    @Column(name = "PACKET", nullable = false)
    private byte[] packet;

    public ServiceScanHistory() {}

    public ServiceScanHistory(DiscoveryPort port, String serviceName, DirectionType direction, byte[] packet, Date createAt) {
        this.port = port;
        this.serviceName = serviceName;
        this.direction = direction;
        this.packet = packet;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public DiscoveryPort getPort() {
        return port;
    }

    public void setPort(DiscoveryPort port) {
        this.port = port;
    }

    public String getServiceName() {
        return serviceName;
    }

    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }

    public DirectionType getDirection() {
        return direction;
    }

    public void setDirection(DirectionType direction) {
        this.direction = direction;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public byte[] getPacket() {
        return packet;
    }

    public void setPacket(byte[] packet) {
        this.packet = packet;
    }
}
